## libhyprcursor 0.1.9

=== CMakeLists.txt ===
cmake_minimum_required(VERSION 3.19)

set(HYPRCURSOR_VERSION "0.1.9")
add_compile_definitions(HYPRCURSOR_VERSION="${HYPRCURSOR_VERSION}")

project(hyprcursor
    VERSION ${HYPRCURSOR_VERSION}
    DESCRIPTION "A library and toolkit for the Hyprland cursor format"
)

include(CTest)
include(GNUInstallDirs)

set(PREFIX ${CMAKE_INSTALL_PREFIX})
set(INCLUDE ${CMAKE_INSTALL_FULL_INCLUDEDIR})
set(LIBDIR ${CMAKE_INSTALL_FULL_LIBDIR})

configure_file(hyprcursor.pc.in hyprcursor.pc @ONLY)

set(CMAKE_CXX_STANDARD 23)

find_package(PkgConfig REQUIRED)
pkg_check_modules(deps REQUIRED IMPORTED_TARGET hyprlang>=0.4.2 libzip cairo librsvg-2.0 tomlplusplus)

if(CMAKE_BUILD_TYPE MATCHES Debug OR CMAKE_BUILD_TYPE MATCHES DEBUG)
    message(STATUS "Configuring hyprcursor in Debug")
    add_compile_definitions(HYPRLAND_DEBUG)
else()
    add_compile_options(-O3)
    message(STATUS "Configuring hyprcursor in Release")
endif()

file(GLOB_RECURSE SRCFILES CONFIGURE_DEPENDS "libhyprcursor/*.cpp" "include/hyprcursor/hyprcursor.hpp" "include/hyprcursor/hyprcursor.h" "include/hyprcursor/shared.h")

add_library(hyprcursor SHARED ${SRCFILES})
target_include_directories( hyprcursor
    PUBLIC "./include"
    PRIVATE "./libhyprcursor"
)
set_target_properties(hyprcursor PROPERTIES
    VERSION ${hyprcursor_VERSION}
    SOVERSION 0
    PUBLIC_HEADER include/hyprcursor/hyprcursor.hpp include/hyprcursor/hyprcursor.h include/hyprcursor/shared.h
)

target_link_libraries(hyprcursor PkgConfig::deps)

if (CMAKE_CXX_COMPILER_ID MATCHES "Clang")
    # for std::expected.
    # probably evil. Arch's clang is very outdated tho...
    target_compile_options(hyprcursor PUBLIC
        $<$<COMPILE_LANGUAGE:CXX>:-std=gnu++2b -D__cpp_concepts=202002L>
        -Wno-builtin-macro-redefined)
endif()

# hyprcursor-util
file(GLOB_RECURSE UTILSRCFILES CONFIGURE_DEPENDS "hyprcursor-util/src/*.cpp" "include/hyprcursor/hyprcursor.hpp" "include/hyprcursor/hyprcursor.h" "include/hyprcursor/shared.h")
add_executable(hyprcursor-util ${UTILSRCFILES})
target_include_directories(hyprcursor-util
    PUBLIC "./include"
    PRIVATE "./libhyprcursor" "./hyprcursor-util/src"
)
target_link_libraries(hyprcursor-util PkgConfig::deps hyprcursor)

# tests
add_custom_target(tests)

add_executable(hyprcursor_test1 "tests/full_rendering.cpp")
target_link_libraries(hyprcursor_test1 PRIVATE hyprcursor)
add_test(NAME "Test libhyprcursor in C++ (full rendering)" WORKING_DIRECTORY ${CMAKE_SOURCE_DIR}/tests COMMAND hyprcursor_test1)
add_dependencies(tests hyprcursor_test1)

add_executable(hyprcursor_test2 "tests/only_metadata.cpp")
target_link_libraries(hyprcursor_test2 PRIVATE hyprcursor)
add_test(NAME "Test libhyprcursor in C++ (only metadata)" WORKING_DIRECTORY ${CMAKE_SOURCE_DIR}/tests COMMAND hyprcursor_test2)
add_dependencies(tests hyprcursor_test2)

add_executable(hyprcursor_test_c "tests/c_test.c")
target_link_libraries(hyprcursor_test_c PRIVATE hyprcursor)
add_test(NAME "Test libhyprcursor in C" WORKING_DIRECTORY ${CMAKE_SOURCE_DIR}/tests COMMAND hyprcursor_test_c)
add_dependencies(tests hyprcursor_test_c)

# Installation
install(TARGETS hyprcursor)
install(TARGETS hyprcursor-util)
install(DIRECTORY "include/hyprcursor" DESTINATION ${CMAKE_INSTALL_INCLUDEDIR})
install(FILES ${CMAKE_BINARY_DIR}/hyprcursor.pc DESTINATION ${CMAKE_INSTALL_LIBDIR}/pkgconfig)

=== debian/changelog ===
libhyprcursor (0.1.9-1build1) plucky; urgency=medium

  * Rebuild against latest libzip

 -- Jeremy Bícha <jbicha@ubuntu.com>  Fri, 22 Nov 2024 08:54:35 -0500

libhyprcursor (0.1.9-1) unstable; urgency=low

  * Initial release. Closes: #1067116

 -- Alan M Varghese (NyxTrail) <alan@digistorm.in>  Mon, 18 Mar 2024 16:41:48 +0000

=== debian/control ===
Source: libhyprcursor
Section: x11
Priority: optional
Maintainer: Alan M Varghese (NyxTrail) <alan@digistorm.in>
Build-Depends: cmake, 
  debhelper-compat (= 13),
  libcairo2-dev,
  libhyprlang-dev (>= 0.4.2),
  librsvg2-dev,
  libtomlplusplus-dev,
  libzip-dev,
  pandoc,
  pkgconf
Standards-Version: 4.6.2
Homepage: https://github.com/hyprwm/hyprcursor
Rules-Requires-Root: no
Vcs-Git: https://salsa.debian.org/NyxTrail/hyprcursor.git
Vcs-Browser: https://salsa.debian.org/NyxTrail/hyprcursor

Package: hyprcursor-util
Architecture: any
Depends: ${misc:Depends}, ${shlibs:Depends}
Description: Utility to manipulate hyprcusor and xcursor themes
 hyprcursor is the cursor format, and associated files and utilities
 for Hyprland.
 .
 This package contains hyprcursor-util; a binary to compile, pack,
 unpack etc the hyprcursor and xcursor themes.

Package: libhyprcursor0
Section: libs
Architecture: any
Depends: ${misc:Depends}, ${shlibs:Depends}
Description: hyprland cursor format, library and utilities
 hyprcursor is the cursor format, and associated files and utilities
 for Hyprland.
 .
 This package contains hyprcursor; a cursor format, library and
 utilities for Hyprland.

Package: libhyprcursor-dev
Section: libdevel
Architecture: any
Depends: ${misc:Depends},
         libhyprcursor0 (= ${binary:Version})
Description: hyprland cursor format, library and utilities (headers)
 hyprcursor is the cursor format, and associated files and utilities
 for Hyprland.
 .
 This package contains the header files for hyprcursor.

=== debian/watch ===
version=4
opts="searchmode=html" \
  https://github.com/hyprwm/hyprcursor/tags \
  https://github.com/hyprwm/hyprcursor/archive/refs/tags/v(\d+.\d+.\d+)\.tar\.gz

## libhyprcursor 0.1.11

=== CMakeLists.txt ===
cmake_minimum_required(VERSION 3.19)

file(READ "${CMAKE_SOURCE_DIR}/VERSION" VER_RAW)
string(STRIP ${VER_RAW} HYPRCURSOR_VERSION)

add_compile_definitions(HYPRCURSOR_VERSION="${HYPRCURSOR_VERSION}")

project(
  hyprcursor
  VERSION ${HYPRCURSOR_VERSION}
  DESCRIPTION "A library and toolkit for the Hyprland cursor format")

include(CTest)
include(GNUInstallDirs)

set(PREFIX ${CMAKE_INSTALL_PREFIX})
set(INCLUDE ${CMAKE_INSTALL_FULL_INCLUDEDIR})
set(LIBDIR ${CMAKE_INSTALL_FULL_LIBDIR})

configure_file(hyprcursor.pc.in hyprcursor.pc @ONLY)

set(CMAKE_CXX_STANDARD 23)

find_package(PkgConfig REQUIRED)
pkg_check_modules(
  deps
  REQUIRED
  IMPORTED_TARGET
  hyprlang>=0.4.2
  libzip
  cairo
  librsvg-2.0
  tomlplusplus)

if(CMAKE_BUILD_TYPE MATCHES Debug OR CMAKE_BUILD_TYPE MATCHES DEBUG)
  message(STATUS "Configuring hyprcursor in Debug")
  add_compile_definitions(HYPRLAND_DEBUG)
else()
  add_compile_options(-O3)
  message(STATUS "Configuring hyprcursor in Release")
endif()

file(
  GLOB_RECURSE
  SRCFILES
  CONFIGURE_DEPENDS
  "libhyprcursor/*.cpp"
  "include/hyprcursor/hyprcursor.hpp"
  "include/hyprcursor/hyprcursor.h"
  "include/hyprcursor/shared.h")

add_library(hyprcursor SHARED ${SRCFILES})
target_include_directories(
  hyprcursor
  PUBLIC "./include"
  PRIVATE "./libhyprcursor")
set_target_properties(
  hyprcursor
  PROPERTIES VERSION ${hyprcursor_VERSION}
             SOVERSION 0
             PUBLIC_HEADER include/hyprcursor/hyprcursor.hpp
             include/hyprcursor/hyprcursor.h include/hyprcursor/shared.h)

target_link_libraries(hyprcursor PkgConfig::deps)

if(CMAKE_CXX_COMPILER_ID MATCHES "Clang")
  # for std::expected. probably evil. Arch's clang is very outdated tho...
  target_compile_options(
    hyprcursor PUBLIC $<$<COMPILE_LANGUAGE:CXX>:-std=gnu++2b
                      -D__cpp_concepts=202002L> -Wno-builtin-macro-redefined)
endif()

# hyprcursor-util
file(
  GLOB_RECURSE
  UTILSRCFILES
  CONFIGURE_DEPENDS
  "hyprcursor-util/src/*.cpp"
  "include/hyprcursor/hyprcursor.hpp"
  "include/hyprcursor/hyprcursor.h"
  "include/hyprcursor/shared.h")
add_executable(hyprcursor-util ${UTILSRCFILES})
target_include_directories(
  hyprcursor-util
  PUBLIC "./include"
  PRIVATE "./libhyprcursor" "./hyprcursor-util/src")
target_link_libraries(hyprcursor-util PkgConfig::deps hyprcursor)

# tests
add_custom_target(tests)

add_executable(hyprcursor_test1 "tests/full_rendering.cpp")
target_link_libraries(hyprcursor_test1 PRIVATE hyprcursor)
add_test(
  NAME "Test libhyprcursor in C++ (full rendering)"
  WORKING_DIRECTORY ${CMAKE_SOURCE_DIR}/tests
  COMMAND hyprcursor_test1)
add_dependencies(tests hyprcursor_test1)

add_executable(hyprcursor_test2 "tests/only_metadata.cpp")
target_link_libraries(hyprcursor_test2 PRIVATE hyprcursor)
add_test(
  NAME "Test libhyprcursor in C++ (only metadata)"
  WORKING_DIRECTORY ${CMAKE_SOURCE_DIR}/tests
  COMMAND hyprcursor_test2)
add_dependencies(tests hyprcursor_test2)

add_executable(hyprcursor_test_c "tests/c_test.c")
target_link_libraries(hyprcursor_test_c PRIVATE hyprcursor)
add_test(
  NAME "Test libhyprcursor in C"
  WORKING_DIRECTORY ${CMAKE_SOURCE_DIR}/tests
  COMMAND hyprcursor_test_c)
add_dependencies(tests hyprcursor_test_c)

# Installation
install(TARGETS hyprcursor)
install(TARGETS hyprcursor-util)
install(DIRECTORY "include/hyprcursor" DESTINATION ${CMAKE_INSTALL_INCLUDEDIR})
install(FILES ${CMAKE_BINARY_DIR}/hyprcursor.pc
        DESTINATION ${CMAKE_INSTALL_LIBDIR}/pkgconfig)

if(INSTALL_TESTS)
  install(TARGETS hyprcursor_test1)
  install(TARGETS hyprcursor_test2)
  install(TARGETS hyprcursor_test_c)
endif()

=== debian/changelog ===
libhyprcursor (0.1.11-1) unstable; urgency=medium

  * New upstream version 0.1.11

 -- Alan M Varghese (NyxTrail) <alan@digistorm.in>  Sun, 02 Mar 2025 08:05:54 +0000

=== debian/control ===
--- 
+++ 
@@ -11,7 +11,7 @@
   libzip-dev,
   pandoc,
   pkgconf
-Standards-Version: 4.6.2
+Standards-Version: 4.7.2
 Homepage: https://github.com/hyprwm/hyprcursor
 Rules-Requires-Root: no
 Vcs-Git: https://salsa.debian.org/NyxTrail/hyprcursor.git

=== debian/rules ===
#!/usr/bin/make -f
export DH_VERBOSE = 1
export DEB_BUILD_MAINT_OPTIONS = hardening=+all
export DEB_CFLAGS_MAINT_APPEND  = -Wall -pedantic
export DEB_LDFLAGS_MAINT_APPEND = -Wl,-O1

%:
	dh $@

override_dh_auto_test:
	:

override_dh_auto_install:
	dh_auto_install
	
	mkdir -p debian/tmp/usr/share/doc/hyprcursor-util
	pandoc debian/hyprcursor-util.1.rst --standalone \
		--variable=header:"hyprcursor-util User Manual" \
		--variable=section:1 \
		--from rst \
		--to man > debian/tmp/usr/share/doc/hyprcursor-util/hyprcursor-util.1

## libhyprcursor 0.1.13

=== CMakeLists.txt ===
--- 
+++ 
@@ -20,6 +20,16 @@
 configure_file(hyprcursor.pc.in hyprcursor.pc @ONLY)
 
 set(CMAKE_CXX_STANDARD 23)
+add_compile_options(
+  -Wall
+  -Wextra
+  -Wpedantic
+  -Wno-unused-parameter
+  -Wno-unused-value
+  -Wno-missing-field-initializers
+  -Wno-narrowing
+  -Wno-pointer-arith)
+set(CMAKE_EXPORT_COMPILE_COMMANDS TRUE)
 
 find_package(PkgConfig REQUIRED)
 pkg_check_modules(
@@ -62,13 +72,6 @@
              include/hyprcursor/hyprcursor.h include/hyprcursor/shared.h)
 
 target_link_libraries(hyprcursor PkgConfig::deps)
-
-if(CMAKE_CXX_COMPILER_ID MATCHES "Clang")
-  # for std::expected. probably evil. Arch's clang is very outdated tho...
-  target_compile_options(
-    hyprcursor PUBLIC $<$<COMPILE_LANGUAGE:CXX>:-std=gnu++2b
-                      -D__cpp_concepts=202002L> -Wno-builtin-macro-redefined)
-endif()
 
 # hyprcursor-util
 file(

=== debian/changelog ===
libhyprcursor (0.1.13-0.1) unstable; urgency=medium

  * Non-maintainer upload
  * New upstream release (Closes: #1106525, #1117188)
  * Updated to watchfile version 5

 -- Carl Keinath <carl.keinath@gmail.com>  Mon, 06 Oct 2025 11:59:22 +0200

libhyprcursor (0.1.12-1) unstable; urgency=medium

  [ alan (NyxTrail) ]
  * New upstream version 0.1.12
  * Update standards version to 4.7.2
  * Add d/gbp.conf for recommended repo layout

 -- Alan M Varghese (NyxTrail) <alan@digistorm.in>  Sun, 04 May 2025 12:05:37 +0000

=== debian/control ===
--- 
+++ 
@@ -2,7 +2,7 @@
 Section: x11
 Priority: optional
 Maintainer: Alan M Varghese (NyxTrail) <alan@digistorm.in>
-Build-Depends: cmake, 
+Build-Depends: cmake,
   debhelper-compat (= 13),
   libcairo2-dev,
   libhyprlang-dev (>= 0.4.2),
@@ -10,7 +10,7 @@
   libtomlplusplus-dev,
   libzip-dev,
   pandoc,
-  pkgconf
+  pkgconf,
 Standards-Version: 4.7.2
 Homepage: https://github.com/hyprwm/hyprcursor
 Rules-Requires-Root: no

=== debian/watch ===
Version: 5

Template: Github
Owner: hyprwm
Project: hyprcursor
